import java.util.concurrent.atomic.AtomicLong
import scala.collection.mutable.ArrayBuffer
import java.io.File
import java.util.Scanner


class Brojac(poc : Int, kraj : Int, 
             linije : ArrayBuffer[String], 
             brA : AtomicLong,
             brC : AtomicLong,
             brG : AtomicLong,
             brT : AtomicLong)
  extends Thread {

  override def run() {
    for(i <- poc until kraj){
      val a = linije(i).count(_=='a')
      val c = linije(i).count(_=='c')
      val g = linije(i).count(_=='g')
      val t = linije(i).count(_=='t')
      
      brA.addAndGet(a)
      brC.addAndGet(c)
      brG.addAndGet(g)
      brT.addAndGet(t)
      
    }
  }
}


object Zad2 {
  def main(args: Array[String]) {
    val sc1 : Scanner = new Scanner(new File("bio_podaci.txt"))
    val sc2 : Scanner = new Scanner(System.in)
    
    println("Unesite broj niti: ")
    
    val brojNiti = sc2.nextInt()
    
    val brojaci = new Array[Brojac](brojNiti)

    val linije = new ArrayBuffer[String]()
    
    while(sc1.hasNextLine())
      linije.append(sc1.nextLine())
      
    val brojLinija = linije.length
        
    val korak = Math.ceil(brojLinija.toDouble/brojNiti.toDouble).toInt
    
    val brA = new AtomicLong(0)
    val brC = new AtomicLong(0)
    val brG = new AtomicLong(0)
    val brT = new AtomicLong(0)
    
    for(i <- 0 until brojNiti)
      brojaci(i) = new Brojac(i*korak, Math.min((i+1)*korak, brojLinija), linije, brA, brC, brG, brT)
    
    for(b <- brojaci)
      b.start()
      
    for(b <- brojaci)
      b.join()
      
    println("Rezultati konkurentnog izvrsavanja")  
    println("A: " + brA.get)
    println("C: " + brC.get)
    println("G: " + brG.get)
    println("T: " + brT.get)
    
    println("Pravi rezultati \nA: 1761 \nC: 1577 \nG: 1589 \nT: 1913")
  }
}